package com.vendor.burn.ui.burners;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.Activator;
import com.vendor.burn.Messages;
import com.vendor.burn.model.define.IBurner;
import com.vendor.burn.model.define.ICheckerBoard;
import com.vendor.burn.model.define.IFastbootProgressMonitor;
import com.vendor.burn.model.event.EventType;
import com.vendor.burn.model.event.FastbootEvent;
import com.vendor.burn.ui.BurnComposite;
import com.vendor.burn.views.LightView;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Layout;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.PlatformUI;

public class BoradCheckComposite extends BurnComposite {
  private Composite control;
  
  private Button btnCheckBorad;
  
  private Text textInfo;
  
  static RGB RGB_RECEIVED = new RGB(255, 0, 0);
  
  static RGB WHITE_RECEIVED = new RGB(255, 255, 255);
  
  public BoradCheckComposite(Composite parent, int style, IBurner burner) {
    super(parent, style, burner);
  }
  
  protected void createContents(Composite parent) {
    this.control = new Composite(parent, 0);
    this.control.setLayout((Layout)new GridLayout(1, false));
    this.control.setLayoutData(new GridData(1808));
    this.btnCheckBorad = new Button(this.control, 8);
    this.btnCheckBorad.setImage(Activator.getImage("icons/fix.png"));
    this.btnCheckBorad.setText(Messages.BoardCheckComposite_CheckBorad_Button);
    this.btnCheckBorad.addListener(13, (Listener)new Object(this));
    GridData btnCheckGD = new GridData(2, 1, true, false);
    btnCheckGD.widthHint = 250;
    this.btnCheckBorad.setLayoutData(btnCheckGD);
    this.textInfo = new Text(this.control, 2570);
    this.textInfo.setLayoutData(new GridData(4, 4, true, true, 1, 1));
    this.textInfo.setText(Messages.BoardCheckComposite_CheckBorad_StartInfo + ":\r\n");
  }
  
  private void checkBoard() {
    IFastbootProgressMonitor monitor = getProgressMonitor();
    monitor.begin();
    ICheckerBoard checker = (ICheckerBoard)getBurner();
    if (checkStatus(checker.checkBeforeCheck())) {
      monitor.getEvent().setBurner((IBurner)checker);
      checker.check(monitor);
    } else {
      monitor.finish();
    } 
  }
  
  private void updateTextInfo(String message) {
    if (this.textInfo.isDisposed())
      return; 
    this.textInfo.setText(message.trim());
    this.textInfo.setForeground(new Color(null, RGB_RECEIVED));
    this.textInfo.setTopIndex(2147483647);
  }
  
  protected Layout createLayout() {
    return (Layout)new GridLayout(1, false);
  }
  
  protected void disableUI() {
    super.disableUI();
    if (this.btnCheckBorad != null && !this.btnCheckBorad.isDisposed())
      this.btnCheckBorad.setEnabled(false); 
  }
  
  protected void enableUI() {
    super.enableUI();
    if (this.btnCheckBorad != null && !this.btnCheckBorad.isDisposed())
      this.btnCheckBorad.setEnabled(true); 
  }
  
  public void started(FastbootEvent event) {
    if (event.getBurner() instanceof com.vendor.burn.model.devices.burners.BoardCheckBurner) {
      if (PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().findView(LightView.ID) != null) {
        IViewPart view = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage().findView(LightView.ID);
        if (view != null) {
          LightView lightView = (LightView)view;
          lightView.getTftplbl().setVisible(false);
        } 
      } 
      super.started(event);
      if (event.getBurner() == getBurner())
        this.btnCheckBorad.setEnabled(false); 
      if (!this.textInfo.isDisposed())
        this.textInfo.setText(Messages.BoardCheckComposite_CheckBorad_StartInfo + ":\r\n"); 
    } 
  }
  
  public void finished(FastbootEvent event) {
    if (event.getBurner() instanceof com.vendor.burn.model.devices.burners.BoardCheckBurner) {
      enableUI();
      if (event.getBurner() == getBurner())
        this.btnCheckBorad.setEnabled(true); 
      if (event.getType() == EventType.CHECK) {
        String message = event.getMessage();
        if (message != null && message.trim().length() != 0)
          updateTextInfo(message); 
      } 
    } 
  }
}
